package Lingua::RU::Antimat;
use strict;
use 5.004;
use FileHandle;

$Lingua::RU::Antimat::VERSION = '1.01';

use locale;
use Encode;

sub new
{
	my $that = shift;
	my $class = ref($that)||$that;
	my $self= {};
	
	my $codepage=shift;

	if (defined($codepage)) {$self->{'codepage'} = $codepage;}

	if (defined($codepage)&&($codepage eq 'koi8')) {
		$self->{'word'}='a[\W_]*s[\W_]*s(?:[\W_]*e[\W_]*s)?|f[\W_]*u[\W_]*c[\W_]*k(?:[\W_]*i[\W_]*n[\W_]*g)?|[\W_]*(?:[iu][\W_]*[d](?:[\W_]*[yiau]|[\W_]*[o0][\W_]*[bv])?|[o0][\W_]*[np][\W_]*(?:[a](?:[\W_]*[xh])?|[eyiu]|[o0][\W_]*[j]))|[d][\W_]*[e][\W_]*[pr][\W_]*(?:[b][\W_]*)?[m][\W_]*[eoya0u](?:[\W_]*[m])?|[c][\W_]*[m][\W_]*(?:[o0]|[i][\W_]*[pr][\W_]*[eibu])|[sc][\W_]*[uy][\W_]*(?:(?:[c][\W_]*)?[k][\W_]*[iyau](?:[\W_]*[hn](?:[\W_]*[o0][\W_]*[j]|[\W_]*[yiau])?)?|[c][\W_]*(?:(?:[b][\W_]*)?(?:[ţeiu]|[eiu][\W_]*[j])|[a][\W_]*[pr][\W_]*[eyiau]))|[rg][\W_]*(?:[oa0][\W_]*(?:[hn][\W_]*[d][\W_]*[oa0][\W_]*[hn](?:[\W_]*[yiu])?|[bv][\W_]*[hn][\W_]*[oa0](?:[\W_]*(?:[m]|[e][\W_]*[d](?:[\W_]*[eyiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?)?))?)|[hn][\W_]*(?:[iu][\W_]*[d][\W_]*(?:[eyiau]|[o0][\W_]*[j])|[yu][sc](?:[\W_]*[yiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?)?))|(?:[hn][\W_]*[e][\W_]*)?(?:(?:[3z][\W_]*[a]|[o0][t]|[np][\W_]*[o0]|[np][\W_]*(?:[e][\W_]*[pr][\W_]*[e]|[pr][\W_]*[eiou0]|[iu][\W_]*[3z][\W_]*[d][\W_]*[o0])|[hn][\W_]*[a]|[iu][\W_]*[3z]|[d][\W_]*[o0]|[bv][\W_]*[i]|[yu]|[pr][\W_]*[a][\W_]*[3z]|[3z][\W_]*[l][\W_]*[o0]|[t][\W_]*[pr][\W_]*[o0]|[yu])[\W_]*)?(?:[bv][\W_]*[i][\W_]*)?(?:[b][\W_]*)?(?:[ţe][\W_]*[b6](?:(?:[\W_]*[ţeioyau0])?(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)?(?:[\W_]*[bv][\W_]*[a])?(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:(?:[b][\W_]*)?[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[o0]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[k](?:[\W_]*[iau])?|[a][\W_]*[l](?:[\W_]*[sc][\W_]*)?|[l][\W_]*(?:[a][\W_]*[hn]|[oa0](?:[\W_]*[m])?|(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu]|[a][\W_]*[sc][\W_]*[b])|[pr][\W_]*[b]|[sc][\W_]*[b]|[hn][\W_]*[o0]|[c][\W_]*(?:[iu][\W_]*[xh]|[e][\W_]*[sc][\W_]*[t][\W_]*[ibu](?:[\W_]*)?)|(?:[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*|[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?)|[ijltcu]))?)|[\W_]*[i](?:(?:[\W_]*[bv][\W_]*[a]|[\W_]*[hn](?:[\W_]*[hn])?)(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:[b][\W_]*[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[l][\W_]*(?:(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu]|[a][\W_]*[sc][\W_]*[b])|(?:[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?))))|[pr][\W_]*[b]))|[\W_]*[b6](?:[\W_]*[ţeioyau0])?(?:(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)?(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:[b][\W_]*[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[k](?:[\W_]*[iau])?|[a][\W_]*[l](?:[\W_]*[sc][\W_]*)?|[l][\W_]*(?:[a][\W_]*[hn]|[oa0](?:[\W_]*[m])?|(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu])|[pr][\W_]*[b]|[sc][\W_]*[b]|[hn][\W_]*[o0]|[c][\W_]*(?:[iu][\W_]*[xh]|[e][\W_]*[sc][\W_]*[t][\W_]*[ibu](?:[\W_]*)?)|(?:[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*|[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?)|[ijlmcu]))|(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)))|[\W_]*[b6][\W_]*(?:[ţeiyau][\W_]*)?(?:[hn][\W_]*(?:[hn][\W_]*)?(?:[iybau][\W_]*)?)?[t])|[sc][\W_]*[b][\W_]*[ѣe][\W_]*[b6][\W_]*(?:[yu]|(?:[ɣeiyau](?:[\W_]*[l](?:[\W_]*[ioau0])?|[\W_]*[\W_]*[b]|[\W_]*[t][\W_]*[e])?(?:[\W_]*[sc][\W_]*[b])?))|[e][\W_]*(?:[b6][\W_]*(?:[yu][\W_]*[k][\W_]*[e][\W_]*[hn][\W_]*[t][\W_]*[iu][\W_]*[j]|[e][\W_]*[hn][\W_]*(?:[b]|(?:[\W_]*[m])?)|[iu][\W_]*(?:[c][\W_]*[k][\W_]*[a][\W_]*|[c][\W_]*[e][\W_]*[sc][\W_]*[k][\W_]*[a][\W_]*)|[l][\W_]*[iu][\W_]*[\W_]*[e]|[a][\W_]*(?:[l][\W_]*[b][\W_]*[hn][\W_]*[iu][\W_]*[k](?:[\W_]*[iau])?|[t][\W_]*[o0][\W_]*[pr][\W_]*[iu][\W_]*[j]|[hn][\W_]*(?:[t][\W_]*[pr][\W_]*[o0][\W_]*[np]|[a][\W_]*[t][\W_]*[iu][\W_]*(?:[k]|[c][\W_]*[e][\W_]*[sc][\W_]*[k][\W_]*[iu][\W_]*[j]))))|[d][\W_]*[pr][\W_]*[iu][\W_]*[t])|[hn][\W_]*[e][\W_]*[bv][\W_]*[pr][\W_]*[o0][\W_]*[t][\W_]*[\W_]*[e][\W_]*[b6][\W_]*[a][\W_]*[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*[iu][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[yu][\W_]*(?:[e][\W_]*[b6][\W_]*(?:[iu][\W_]*[\W_]*[ea]|[a][\W_]*[hn](?:[\W_]*[t][\W_]*[yu][\W_]*[sc])?(?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eyiau])?)|[pr][\W_]*[o0][\W_]*[d](?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eyiau])?|[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*(?:[o0][\W_]*[k]|[k][\W_]*(?:[oa0][\W_]*[bmv](?:[\W_]*[iu])?|[eiyau])?))|[m][\W_]*(?:[yu][\W_]*[d][\W_]*(?:[o0][\W_]*[xh][\W_]*[a][\W_]*(?:[t][\W_]*[b][\W_]*[sc][\W_]*|[\W_]*[sc][\W_]*[b]|[e][\W_]*[\W_]*[b][\W_]*[sc][\W_]*)|[a][\W_]*(?:[k](?:[\W_]*[iau]|[o0][bmv])?|[c][\W_]*(?:[b][\W_]*[ţe]|[iu][\W_]*[hn][\W_]*[yiau]|[k][\W_]*(?:[eiyau]|[o0][\W_]*[j])))|[e][\W_]*[hn][\W_]*[b]|[iu][\W_]*[l](?:[\W_]*[eoia0]?))|[a][\W_]*[hn][\W_]*[d][\W_]*[yau]|[l][\W_]*(?:[iu][\W_]*[hn]|))|(?:[m][\W_]*(?:[o0][\W_]*[3z][\W_]*[rg]|[yu][\W_]*[d])|[d][\W_]*(?:[o0][\W_]*[l][\W_]*[b6]|[yu][\W_]*[pr])|[sc][\W_]*[k][\W_]*[o0][\W_]*[t]|[\W_]*[iu][\W_]*[d])[\W_]*[oa0][\W_]*(?:[xh][\W_]*[yu][\W_]*[iju]|[e][\W_]*[b6](?:[\W_]*[eo0][\W_]*[bv]|[\W_]*[ia]|[\W_]*[sc][\W_]*[t][\W_]*[bv][\W_]*[oy0u](?:[\W_]*[m])?|[iu][\W_]*[3z][\W_]*[m])?)|(?:[hn][\W_]*[e][\W_]*|[3z][\W_]*[a][\W_]*|[o0][\W_]*[t][\W_]*|[np][\W_]*[o0][\W_]*|[hn][\W_]*[a][\W_]*|[pr][\W_]*[a][\W_]*[3szc][\W_]*)?(?:[np][\W_]*[iu][\W_]*[3z][\W_]*[d][\W_]*[eiu]|(?:)?[ţe][\W_]*[b6][\W_]*[a])[\W_]*(?:(?:[t][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*[b]|[l][\W_]*[iu]|[a][\W_]*[l]|[l]|c[\W_]*[b]|[iu][\W_]*[t]|[iu]|[t][\W_]*[e]|[c][\W_]*[yu]|[\W_]*[b])|(?:[iju]|[eiu][\W_]*[m](?:[\W_]*[iu])?|[j][\W_]*[sc][\W_]*(?:[k][\W_]*(?:[iu][\W_]*[ej]|[a][\W_]*|[o0][\W_]*[e]|[i][\W_]*[xh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[t][\W_]*[bv][\W_]*[oya0u](?:[\W_]*[m])?)))|[np][\W_]*[eiu][\W_]*[d][\W_]*[eoa0][\W_]*[pr](?:(?:[\W_]*[a][\W_]*[3szc](?:(?:[\W_]*[t])?(?:[\W_]*[i]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[\W_]*[k][\W_]*[iau])?|(?:[\W_]*[eyiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[\W_]*[o0][\W_]*[bv])))|[\W_]*(?:[eyiau]|[oa0][\W_]*[m](?:[\W_]*[iu])?|[o0][\W_]*[bv]|[hn][\W_]*))?|[np][\W_]*[iu][\W_]*[3z][\W_]*(?:[b][\W_]*)?[d][\W_]*(?:[e][\W_]*(?:[hn][\W_]*[i][\W_]*(?:[\W_]*[b])?|[hn](?:[\W_]*[b])?)|[yu][\W_]*(?:[j](?:[\W_]*[t][\W_]*[e])?|[hn](?:[\W_]*[i])?)|[\W_]*(?:[k](?:[\W_]*(?:[eiyau]|[o0][\W_]*[bv]|[a][\W_]*[m](?:[\W_]*[iu])?))?|[l](?:[ibu]|[e][\W_]*[j]|[\W_]*[mxh]))|[e][\W_]*[c]|[oa0][\W_]*(?:[hn][\W_]*[yu][\W_]*)?[t][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0](?:[\W_]*[ej])?|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu]|[e][\W_]*[e]|[eyibau])|[a][\W_]*[hn][\W_]*[yu][\W_]*[l](?:[\W_]*[iau])?|[eiyau]|[oa0][\W_]*(?:[j]|[xh][\W_]*[yu][\W_]*[j]|[ţe][\W_]*[b6]|(?:[pr][\W_]*[o0][\W_]*[t]|[rg][\W_]*[o0][\W_]*[l][\W_]*[o0][\W_]*[bv])[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[b6][\W_]*(?:[pr][\W_]*[a][\W_]*[t][\W_]*[iu][\W_]*|[o0][\W_]*[l](?:[\W_]*[yiau])?)))|[np][\W_]*(?:[a][\W_]*[d][\W_]*[l][\W_]*[oia0]|[oa0][\W_]*[sc][\W_]*[k][\W_]*[yu][\W_]*[d][\W_]*(?:[eyiau]|[oa0][\W_]*[m](?:[\W_]*[iu])?)|[eiu][\W_]*[d][\W_]*(?:[iu][\W_]*[k]|[pr][\W_]*[iu][\W_]*[l](?:[\W_]*[l])?)(?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eioyau0])?|[pr][\W_]*[o0][\W_]*[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*[o0][\W_]*[m])|(?:[3z][\W_]*[a][\W_]*|[o0][\W_]*[t][\W_]*|[hn][\W_]*[a][\W_]*)?[sc][\W_]*[pr][\W_]*(?:[a][\W_]*[t][\W_]*[b]|[a][\W_]*[l](?:[\W_]*[iu])?|[eiyu])|[sc][\W_]*[pr][\W_]*[a][\W_]*(?:[k][\W_]*(?:[eiyau]|[o0][\W_]*[j])|[hn](?:[\W_]*[hn])?(?:[b]|(?:[\W_]*[i][\W_]*[ej]|[\W_]*[a][\W_]*|[\W_]*[o0][\W_]*[e]))|[l][\W_]*[b][\W_]*[hn][\W_]*[iu][\W_]*[k](?:[\W_]*[iu]|[\W_]*[oa0][\W_]*[m])?)|(?:[3z][\W_]*[a][\W_]*)?[t][\W_]*[pr][\W_]*[a][\W_]*[xh][\W_]*(?:[hn][\W_]*(?:[yu](?:[\W_]*[t][\W_]*[b](?:[\W_]*[sc][\W_]*)?|[\W_]*[sc][\W_]*[b]|[\W_]*[l](?:[\W_]*[iau])?)?|[eiu][\W_]*[\W_]*[b][\W_]*[sc][\W_]*)|[a][\W_]*(?:[l](?:[\W_]*[ioau0])?|[t][\W_]*[b](?:[\W_]*[sc][\W_]*)?|[hn][\W_]*(?:[hn][\W_]*)?(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])))|(?:[hn][\W_]*[eiu][\W_]*|[np][\W_]*[o0][\W_]*|[hn][\W_]*[a][\W_]*|[oa0][\W_]*(?:[t][\W_]*)?|[d][\W_]*[oa0][\W_]*|[3z][\W_]*[a][\W_]*)?(?:(?:[f][\W_]*[iu][\W_]*[rg]|[xh][\W_]*(?:[eiu][\W_]*(?:[j][\W_]*)?[pr]|[pr][\W_]*[e][\W_]*[hn]|[yu](?:[\W_]*[j])?))(?:[\W_]*[ϣeo0][\W_]*[bv](?:[\W_]*[a][\W_]*[\W_]*|[\W_]*)?)?(?:[\W_]*[eiau][\W_]*[lhn])?(?:[hn])?(?:[\W_]*(?:[ϣeioau0][beijmvu]|[\W_]*(?:[m](?:[\W_]*[iu])?|[pr][\W_]*(?:|[iu][\W_]*(?:[t](?:[\W_]*[eb][\W_]*[sc][\W_]*[b])?|[l](?:[\W_]*[ioau0])?))|[c][\W_]*(?:[iau][\W_]*[t](?:[\W_]*[sc][\W_]*)|[iu][\W_]*[l](?:[\W_]*[ioau0])?)|[c](?:[\W_]*[b])?)|[e][\W_]*(?:[t][\W_]*(?:[o0][\W_]*[j]|[ybau])|[e][\W_]*(?:[t][\W_]*[e]|[\W_]*[b]))|[ijoyau0]|[l][\W_]*[iou0]|[c][\W_]*[yu])))|(?:[f][\W_]*[iu][\W_]*[rg]|[xh][\W_]*(?:[eiu][\W_]*(?:[j][\W_]*)?[pr]|[pr][\W_]*[e][\W_]*[hn]|[yu][\W_]*[j]))|[xh][\W_]*[yu][\W_]*(?:[ţeiu][\W_]*(?:[sc][\W_]*[o0][\W_]*[sc]|[np][\W_]*[l][\W_]*[e][\W_]*[t]|[hn][\W_]*[i][\W_]*)(?:[\W_]*[yiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[hn][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu]))?|[d][\W_]*[o0][\W_]*[\W_]*[b6][\W_]*[iu][\W_]*[hn][\W_]*(?:[o0][\W_]*[j]|[eyiau]))|[b6][\W_]*[l][\W_]*(?:[\W_]*[dt][\W_]*(?:[b]|[iu]|[k][\W_]*[iu]|[sc][\W_]*[t][\W_]*[bv][\W_]*[o0]|[sc][\W_]*[k][\W_]*(?:[o0][\W_]*[ej]|[iu][\W_]*[e]|[a][\W_]*|[iu][\W_]*[j]|[o0][\W_]*[rg][\W_]*[o0])))?|[bv][\W_]*[i][\W_]*[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*(?:[o0][\W_]*[k]|[k][\W_]*(?:[eiyau]|[a][\W_]*[m](?:[\W_]*[iu])?))|(?:[3z][\W_]*[oa0][\W_]*)(?:[np][\W_]*[oa0][\W_]*[d][\W_]*[l][\W_]*[oia0]|[l][\W_]*[yu][\W_]*[np][\W_]*(?:[o0][\W_]*[j]|[eyiau]))|[\W_]*[l][\W_]*[\W_]*[xh][\W_]*(?:[eiyau]|[o0][\W_]*[j])|[a][\W_]*[hn][\W_]*[yu][\W_]*[sc](?:[\W_]*[eyiau]|[\W_]*[o0][\W_]*[m])?|(?:\w*(?:[xh](?:[pr][e][hn]|[yu][iu])|[np][eiu](?:[3z][d]|[d](?:[eoa0][pr]|[pr]))|[b6][l][d]|[o0][xh][yu][e]|[m][yu][d][eioau0]|[d][e][pr][b]|[rg][oa0][bv][hn]|[yu][ţe][b6])|[xh][\W_]*(?:[pr][\W_]*[e][\W_]*[hn]|[yu][\W_]*[eiju])|[np][\W_]*[eiu][\W_]*(?:[3z][\W_]*[d]|[d][\W_]*(?:[eoa0][\W_]*[pr]|[pr]))|[b6][\W_]*[l][\W_]*[\W_]*[d]|[o0][\W_]*[xh][\W_]*[yu][\W_]*[e]|[m][\W_]*[yu][\W_]*[d][\W_]*[eioau0]|[d][\W_]*[e][\W_]*[pr][\W_]*[b]|[rg][\W_]*[oa0][\W_]*[bv][\W_]*[hn]|[yu][\W_]*[ţe][\W_]*[b6]|[e][b6])\w+';
		$self->{'bip'}='';
	} elsif (defined($codepage)&&($codepage eq 'utf-8')) {
		$self->{'word'}='a[\W_]*s[\W_]*s(?:[\W_]*e[\W_]*s)?|f[\W_]*u[\W_]*c[\W_]*k(?:[\W_]*i[\W_]*n[\W_]*g)?|ж[\W_]*(?:[ыиiu][\W_]*[дd](?:[\W_]*[уыаyiau]|[\W_]*[оo0][\W_]*[вbv])?|[оo0][\W_]*[пnp][\W_]*(?:[аa](?:[\W_]*[хxh])?|[уеыeyiu]|[оo0][\W_]*[йj]))|[дd][\W_]*[еe][\W_]*[рpr][\W_]*(?:[ьb][\W_]*)?[мm][\W_]*[оуеаeoya0u](?:[\W_]*[мm])?|[чc][\W_]*[мm][\W_]*(?:[оo0]|[ыi][\W_]*[рpr][\W_]*[еиьяeibu])|[сsc][\W_]*[уuy][\W_]*(?:(?:[чc][\W_]*)?[кk][\W_]*[ауиiyau](?:[\W_]*[нhn](?:[\W_]*[оo0][\W_]*[йj]|[\W_]*[уаыyiau])?)?|[чc][\W_]*(?:(?:[ьb][\W_]*)?(?:[еёяиeiu]|[еиeiu][\W_]*[йj])|[аa][\W_]*[рpr][\W_]*[ыауеeyiau]))|[гrg][\W_]*(?:[аоoa0][\W_]*(?:[нhn][\W_]*[дd][\W_]*[аоoa0][\W_]*[нhn](?:[\W_]*[ыуyiu])?|[вbv][\W_]*[нhn][\W_]*[оаoa0](?:[\W_]*(?:[мm]|[еe][\W_]*[дd](?:[\W_]*[ыуаеeyiau]|[\W_]*[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?)?))?)|[нhn][\W_]*(?:[иiu][\W_]*[дd][\W_]*(?:[ыуеаeyiau]|[оo0][\W_]*[йj])|[уyu][сsc](?:[\W_]*[аыуyiau]|[\W_]*[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?)?))|(?:[нhn][\W_]*[еe][\W_]*)?(?:(?:[з3z][\W_]*[аa]|[оo0][тt]|[пnp][\W_]*[оo0]|[пnp][\W_]*(?:[еe][\W_]*[рpr][\W_]*[еe]|[рpr][\W_]*[оеиeiou0]|[иiu][\W_]*[з3z][\W_]*[дd][\W_]*[оo0])|[нhn][\W_]*[аa]|[иiu][\W_]*[з3z]|[дd][\W_]*[оo0]|[вbv][\W_]*[ыi]|[уyu]|[рpr][\W_]*[аa][\W_]*[з3z]|[з3z][\W_]*[лl][\W_]*[оo0]|[тt][\W_]*[рpr][\W_]*[оo0]|[уyu])[\W_]*)?(?:[вbv][\W_]*[ыi][\W_]*)?(?:[ъьb][\W_]*)?(?:[еёe][\W_]*[бb6](?:(?:[\W_]*[оеёаиуeioyau0])?(?:[\W_]*[нhn](?:[\W_]*[нhn])?[\W_]*[яуаиьiybau]?)?(?:[\W_]*[вbv][\W_]*[аa])?(?:(?:[\W_]*(?:[иеeiu]ш[\W_]*[ьb][\W_]*[сsc][\W_]*я|[тt][\W_]*(?:(?:[ьb][\W_]*)?[сsc][\W_]*я|[ьb]|[еe][\W_]*[сsc][\W_]*[ьb]|[еe]|[оo0]|[иiu][\W_]*[нhn][\W_]*[уыеаeyiau])|(?:щ[\W_]*(?:[иiu][\W_]*[йj]|[аa][\W_]*я|[иеeiu][\W_]*[еe]|[еe][\W_]*[гrg][\W_]*[оo0])|ю[\W_]*[тt])(?:[\W_]*[сsc][\W_]*я)?|[еe][\W_]*[мтmt]|[кk](?:[\W_]*[иаiau])?|[аa][\W_]*[лl](?:[\W_]*[сsc][\W_]*я)?|[лl][\W_]*(?:[аa][\W_]*[нhn]|[оаoa0](?:[\W_]*[мm])?|(?:[иiu][\W_]*)?[сsc][\W_]*[ьяb]|[иiu]|[аa][\W_]*[сsc][\W_]*[ьb])|[рpr][\W_]*[ьb]|[сsc][\W_]*[яьb]|[нhn][\W_]*[оo0]|[чc][\W_]*(?:[иiu][\W_]*[хxh]|[еe][\W_]*[сsc][\W_]*[тt][\W_]*[ьиibu](?:[\W_]*ю)?)|(?:[тt][\W_]*[еe][\W_]*[лl][\W_]*[ьb][\W_]*[сsc][\W_]*[кk][\W_]*|[сsc][\W_]*[тt][\W_]*|[лl][\W_]*[иiu][\W_]*[вbv][\W_]*|[чтtc][\W_]*)?(?:[аa][\W_]*я|[оo0][\W_]*[йемejm]|[ыi][\W_]*[хйеejxh]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[иiu][\W_]*[еe]|[оo0][\W_]*[мm][\W_]*[уyu]|[иiu][\W_]*[йj]|[еe][\W_]*[вbv]|[иiu][\W_]*[мm](?:[\W_]*[иiu])?)|[чтыйилijltcu]))?)|[\W_]*[ыi](?:(?:[\W_]*[вbv][\W_]*[аa]|[\W_]*[нhn](?:[\W_]*[нhn])?)(?:(?:[\W_]*(?:[иеeiu]ш[\W_]*[ьb][\W_]*[сsc][\W_]*я|[тt][\W_]*(?:[ьb][\W_]*[сsc][\W_]*я|[ьb]|[еe][\W_]*[сsc][\W_]*[ьb]|[еe]|[иiu][\W_]*[нhn][\W_]*[уыеаeyiau])|(?:щ[\W_]*(?:[иiu][\W_]*[йj]|[аa][\W_]*я|[иеeiu][\W_]*[еe]|[еe][\W_]*[гrg][\W_]*[оo0])|ю[\W_]*[тt])(?:[\W_]*[сsc][\W_]*я)?|[еe][\W_]*[мтmt]|[лl][\W_]*(?:(?:[иiu][\W_]*)?[сsc][\W_]*[ьяb]|[иiu]|[аa][\W_]*[сsc][\W_]*[ьb])|(?:[сsc][\W_]*[тt][\W_]*|[лl][\W_]*[иiu][\W_]*[вbv][\W_]*|[чтtc][\W_]*)?(?:[аa][\W_]*я|[оo0][\W_]*[йемejm]|[ыi][\W_]*[хйеejxh]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[иiu][\W_]*[еe]|[оo0][\W_]*[мm][\W_]*[уyu]|[иiu][\W_]*[йj]|[еe][\W_]*[вbv]|[иiu][\W_]*[мm](?:[\W_]*[иiu])?))))|[рpr][\W_]*[ьb]))|я[\W_]*[бb6](?:[\W_]*[оеёаиуeioyau0])?(?:(?:[\W_]*[нhn](?:[\W_]*[нhn])?[\W_]*[яуаиьiybau]?)?(?:(?:[\W_]*(?:[иеeiu]ш[\W_]*[ьb][\W_]*[сsc][\W_]*я|[тt][\W_]*(?:[ьb][\W_]*[сsc][\W_]*я|[ьb]|[еe][\W_]*[сsc][\W_]*[ьb]|[еe]|[иiu][\W_]*[нhn][\W_]*[уыеаeyiau])|(?:щ[\W_]*(?:[иiu][\W_]*[йj]|[аa][\W_]*я|[иеeiu][\W_]*[еe]|[еe][\W_]*[гrg][\W_]*[оo0])|ю[\W_]*[тt])(?:[\W_]*[сsc][\W_]*я)?|[еe][\W_]*[мтmt]|[кk](?:[\W_]*[иаiau])?|[аa][\W_]*[лl](?:[\W_]*[сsc][\W_]*я)?|[лl][\W_]*(?:[аa][\W_]*[нhn]|[оаoa0](?:[\W_]*[мm])?|(?:[иiu][\W_]*)?[сsc][\W_]*[ьяb]|[иiu])|[рpr][\W_]*[ьb]|[сsc][\W_]*[яьb]|[нhn][\W_]*[оo0]|[чc][\W_]*(?:[иiu][\W_]*[хxh]|[еe][\W_]*[сsc][\W_]*[тt][\W_]*[ьиibu](?:[\W_]*ю)?)|(?:[тt][\W_]*[еe][\W_]*[лl][\W_]*[ьb][\W_]*[сsc][\W_]*[кk][\W_]*|[сsc][\W_]*[тt][\W_]*|[лl][\W_]*[иiu][\W_]*[вbv][\W_]*|[чтtc][\W_]*)?(?:[аa][\W_]*я|[оo0][\W_]*[йемejm]|[ыi][\W_]*[хйеejxh]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[иiu][\W_]*[еe]|[оo0][\W_]*[мm][\W_]*[уyu]|[иiu][\W_]*[йj]|[еe][\W_]*[вbv]|[иiu][\W_]*[мm](?:[\W_]*[иiu])?)|[чмйилijlmcu]))|(?:[\W_]*[нhn](?:[\W_]*[нhn])?[\W_]*[яуаиьiybau]?)))|я[\W_]*[бb6][\W_]*(?:[еёаиуeiyau][\W_]*)?(?:[нhn][\W_]*(?:[нhn][\W_]*)?(?:[яуаиьiybau][\W_]*)?)?[тt])|[сsc][\W_]*[ьъb][\W_]*[еяёe][\W_]*[бb6][\W_]*(?:[уyu]|(?:[еиёауeiyau](?:[\W_]*[лl](?:[\W_]*[иоаioau0])?|[\W_]*ш[\W_]*[ьb]|[\W_]*[тt][\W_]*[еe])?(?:[\W_]*[сsc][\W_]*[ьяb])?))|[еe][\W_]*(?:[бb6][\W_]*(?:[уyu][\W_]*[кk][\W_]*[еe][\W_]*[нhn][\W_]*[тt][\W_]*[иiu][\W_]*[йj]|[еe][\W_]*[нhn][\W_]*(?:[ьb]|я(?:[\W_]*[мm])?)|[иiu][\W_]*(?:[цc][\W_]*[кk][\W_]*[аa][\W_]*я|[чc][\W_]*[еe][\W_]*[сsc][\W_]*[кk][\W_]*[аa][\W_]*я)|[лl][\W_]*[иiu][\W_]*щ[\W_]*[еe]|[аa][\W_]*(?:[лl][\W_]*[ьb][\W_]*[нhn][\W_]*[иiu][\W_]*[кk](?:[\W_]*[иаiau])?|[тt][\W_]*[оo0][\W_]*[рpr][\W_]*[иiu][\W_]*[йj]|[нhn][\W_]*(?:[тt][\W_]*[рpr][\W_]*[оo0][\W_]*[пnp]|[аa][\W_]*[тt][\W_]*[иiu][\W_]*(?:[кk]|[чc][\W_]*[еe][\W_]*[сsc][\W_]*[кk][\W_]*[иiu][\W_]*[йj]))))|[дd][\W_]*[рpr][\W_]*[иiu][\W_]*[тt])|[нhn][\W_]*[еe][\W_]*[вbv][\W_]*[рpr][\W_]*[оo0][\W_]*[тt][\W_]*ъ[\W_]*[еe][\W_]*[бb6][\W_]*[аa][\W_]*[тt][\W_]*[еe][\W_]*[лl][\W_]*[ьb][\W_]*[сsc][\W_]*[кk][\W_]*[иiu][\W_]*(?:[ыиiu][\W_]*[йj]|[аa][\W_]*я|[оo0][\W_]*[ейej]|[ыi][\W_]*[хxh]|[ыi][\W_]*[еe]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu])|[уyu][\W_]*(?:[ёеe][\W_]*[бb6][\W_]*(?:[иiu][\W_]*щ[\W_]*[еаea]|[аa][\W_]*[нhn](?:[\W_]*[тt][\W_]*[уyu][\W_]*[сsc])?(?:[\W_]*[аоoa0][\W_]*[вмbmv]|[\W_]*[ыуеаeyiau])?)|[рpr][\W_]*[оo0][\W_]*[дd](?:[\W_]*[аоoa0][\W_]*[вмbmv]|[\W_]*[ыуеаeyiau])?|[бb6][\W_]*[лl][\W_]*ю[\W_]*[дd][\W_]*(?:[оo0][\W_]*[кk]|[кk][\W_]*(?:[аоoa0][\W_]*[вмbmv](?:[\W_]*[иiu])?|[иуеаeiyau])?))|[мm][\W_]*(?:[уyu][\W_]*[дd][\W_]*(?:[оo0][\W_]*[хxh][\W_]*[аa][\W_]*(?:[тt][\W_]*[ьb][\W_]*[сsc][\W_]*я|ю[\W_]*[сsc][\W_]*[ьb]|[еe][\W_]*ш[\W_]*[ьb][\W_]*[сsc][\W_]*я)|[аa][\W_]*(?:[кk](?:[\W_]*[иаiau]|[оo0][мвbmv])?|[чc][\W_]*(?:[ьb][\W_]*[еёe]|[иiu][\W_]*[нhn][\W_]*[уыаyiau]|[кk][\W_]*(?:[аиеуeiyau]|[оo0][\W_]*[йj])))|[еe][\W_]*[нhn][\W_]*[ьb]|[иiu][\W_]*[лl](?:[\W_]*[аеоыeoia0]?))|[аa][\W_]*[нhn][\W_]*[дd][\W_]*[уаyau]|[лl][\W_]*(?:[иiu][\W_]*[нhn]|я))|(?:[мm][\W_]*(?:[оo0][\W_]*[з3z][\W_]*[гrg]|[уyu][\W_]*[дd])|[дd][\W_]*(?:[оo0][\W_]*[лl][\W_]*[бb6]|[уyu][\W_]*[рpr])|[сsc][\W_]*[кk][\W_]*[оo0][\W_]*[тt]|ж[\W_]*[иiu][\W_]*[дd])[\W_]*[аоoa0][\W_]*(?:[хxh][\W_]*[уyu][\W_]*[ийяiju]|[ёеe][\W_]*[бb6](?:[\W_]*[еоeo0][\W_]*[вbv]|[\W_]*[ыаia]|[\W_]*[сsc][\W_]*[тt][\W_]*[вbv][\W_]*[оуoy0u](?:[\W_]*[мm])?|[иiu][\W_]*[з3z][\W_]*[мm])?)|(?:[нhn][\W_]*[еe][\W_]*|[з3z][\W_]*[аa][\W_]*|[оo0][\W_]*[тt][\W_]*|[пnp][\W_]*[оo0][\W_]*|[нhn][\W_]*[аa][\W_]*|[рpr][\W_]*[аa][\W_]*[сз3szc][\W_]*)?(?:[пnp][\W_]*[иiu][\W_]*[з3z][\W_]*[дd][\W_]*[ияеeiu]|(?:ъ)?[еёe][\W_]*[бb6][\W_]*[аa])[\W_]*(?:(?:[тt][\W_]*[ьb][\W_]*[сsc][\W_]*я|[тt][\W_]*[ьb]|[лl][\W_]*[иiu]|[аa][\W_]*[лl]|[лl]|c[\W_]*[ьb]|[иiu][\W_]*[тt]|[иiu]|[тt][\W_]*[еe]|[чc][\W_]*[уyu]|ш[\W_]*[ьb])|(?:[йяиiju]|[иеeiu][\W_]*[мm](?:[\W_]*[иiu])?|[йj][\W_]*[сsc][\W_]*(?:[кk][\W_]*(?:[ыиiu][\W_]*[йеej]|[аa][\W_]*я|[оo0][\W_]*[еe]|[ыi][\W_]*[хxh]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu])|[тt][\W_]*[вbv][\W_]*[оуаoya0u](?:[\W_]*[мm])?)))|[пnp][\W_]*[еиыeiu][\W_]*[дd][\W_]*[аеэоeoa0][\W_]*[рpr](?:(?:[\W_]*[аa][\W_]*[сз3szc](?:(?:[\W_]*[тt])?(?:[\W_]*[ыi]|[\W_]*[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?|[\W_]*[кk][\W_]*[аиiau])?|(?:[\W_]*[ыуаеeyiau]|[\W_]*[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?|[\W_]*[оo0][\W_]*[вbv])))|[\W_]*(?:[ыуаеeyiau]|[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?|[оo0][\W_]*[вbv]|[нhn][\W_]*я))?|[пnp][\W_]*[иiu][\W_]*[з3z][\W_]*(?:[ьb][\W_]*)?[дd][\W_]*(?:[ёеe][\W_]*(?:[нhn][\W_]*[ыi][\W_]*ш(?:[\W_]*[ьb])?|[шнжhn](?:[\W_]*[ьb])?)|[уyu][\W_]*(?:[йj](?:[\W_]*[тt][\W_]*[еe])?|[нhn](?:[\W_]*[ыi])?)|ю[\W_]*(?:[кk](?:[\W_]*(?:[аеуиeiyau]|[оo0][\W_]*[вbv]|[аa][\W_]*[мm](?:[\W_]*[иiu])?))?|[лl](?:[ьиibu]|[еe][\W_]*[йj]|я[\W_]*[хмmxh]))|[еe][\W_]*[цc]|[аоoa0][\W_]*(?:[нhn][\W_]*[уyu][\W_]*)?[тt][\W_]*(?:[иiu][\W_]*[йj]|[аa][\W_]*я|[оo0](?:[\W_]*[ейej])?|[ыi][\W_]*[ейхejxh]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu]|[еe][\W_]*[еe]|[ауьеыeyibau])|[аa][\W_]*[нhn][\W_]*[уyu][\W_]*[лl](?:[\W_]*[аиiau])?|[ыеуиаeiyau]|[оаoa0][\W_]*(?:[йj]|[хxh][\W_]*[уyu][\W_]*[йj]|[еёe][\W_]*[бb6]|(?:[рpr][\W_]*[оo0][\W_]*[тt]|[гrg][\W_]*[оo0][\W_]*[лl][\W_]*[оo0][\W_]*[вbv])[\W_]*(?:[ыиiu][\W_]*[йj]|[аa][\W_]*я|[оo0][\W_]*[ейej]|[ыi][\W_]*[хxh]|[ыi][\W_]*[еe]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu])|[бb6][\W_]*(?:[рpr][\W_]*[аa][\W_]*[тt][\W_]*[иiu][\W_]*я|[оo0][\W_]*[лl](?:[\W_]*[аыуyiau])?)))|[пnp][\W_]*(?:[аa][\W_]*[дd][\W_]*[лl][\W_]*[аоыoia0]|[оаoa0][\W_]*[сsc][\W_]*[кk][\W_]*[уyu][\W_]*[дd][\W_]*(?:[ыуаеeyiau]|[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?)|[иеeiu][\W_]*[дd][\W_]*(?:[иiu][\W_]*[кk]|[рpr][\W_]*[иiu][\W_]*[лl](?:[\W_]*[лl])?)(?:[\W_]*[оаoa0][\W_]*[мвbmv]|[\W_]*[иуеоыаeioyau0])?|[рpr][\W_]*[оo0][\W_]*[бb6][\W_]*[лl][\W_]*я[\W_]*[дd][\W_]*[оo0][\W_]*[мm])|(?:[з3z][\W_]*[аa][\W_]*|[оo0][\W_]*[тt][\W_]*|[нhn][\W_]*[аa][\W_]*)?[сsc][\W_]*[рpr][\W_]*(?:[аa][\W_]*[тt][\W_]*[ьb]|[аa][\W_]*[лl](?:[\W_]*[иiu])?|[eуиiyu])|[сsc][\W_]*[рpr][\W_]*[аa][\W_]*(?:[кk][\W_]*(?:[аеиуeiyau]|[оo0][\W_]*[йj])|[нhn](?:[\W_]*[нhn])?(?:[ьb]|(?:[\W_]*[ыi][\W_]*[йеej]|[\W_]*[аa][\W_]*я|[\W_]*[оo0][\W_]*[еe]))|[лl][\W_]*[ьb][\W_]*[нhn][\W_]*[иiu][\W_]*[кk](?:[\W_]*[иiu]|[\W_]*[оаoa0][\W_]*[мm])?)|(?:[з3z][\W_]*[аa][\W_]*)?[тt][\W_]*[рpr][\W_]*[аa][\W_]*[хxh][\W_]*(?:[нhn][\W_]*(?:[уyu](?:[\W_]*[тt][\W_]*[ьb](?:[\W_]*[сsc][\W_]*я)?|[\W_]*[сsc][\W_]*[ьb]|[\W_]*[лl](?:[\W_]*[аиiau])?)?|[еиeiu][\W_]*ш[\W_]*[ьb][\W_]*[сsc][\W_]*я)|[аa][\W_]*(?:[лl](?:[\W_]*[аоиioau0])?|[тt][\W_]*[ьb](?:[\W_]*[сsc][\W_]*я)?|[нhn][\W_]*(?:[нhn][\W_]*)?(?:[ыиiu][\W_]*[йj]|[аa][\W_]*я|[оo0][\W_]*[йеej]|[ыi][\W_]*[хxh]|[ыi][\W_]*[еe]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu])))|(?:[нhn][\W_]*[иеeiu][\W_]*|[пnp][\W_]*[оo0][\W_]*|[нhn][\W_]*[аa][\W_]*|[оаoa0][\W_]*(?:[тt][\W_]*)?|[дd][\W_]*[аоoa0][\W_]*|[з3z][\W_]*[аa][\W_]*)?(?:(?:[фf][\W_]*[иiu][\W_]*[гrg]|[хxh][\W_]*(?:[еиeiu][\W_]*(?:[йj][\W_]*)?[рpr]|[рpr][\W_]*[еe][\W_]*[нhn]|[уyu](?:[\W_]*[йj])?))(?:[\W_]*[еоёeo0][\W_]*[вbv](?:[\W_]*[аa][\W_]*ю[\W_]*щ|[\W_]*ш)?)?(?:[\W_]*[аиеeiau][\W_]*[лнlhn])?(?:[нhn])?(?:[\W_]*(?:[иаоёяыеeioau0][юяиевмйbeijmvu]|я[\W_]*(?:[мm](?:[\W_]*[иiu])?|[рpr][\W_]*(?:ю|[иiu][\W_]*(?:[тt](?:[\W_]*[ьеeb][\W_]*[сsc][\W_]*[яьb])?|[лl](?:[\W_]*[иоаioau0])?))|[чc][\W_]*(?:[аиiau][\W_]*[тt](?:[\W_]*[сsc][\W_]*я)|[иiu][\W_]*[лl](?:[\W_]*[иоаioau0])?)|[чc](?:[\W_]*[ьb])?)|[еe][\W_]*(?:[тt][\W_]*(?:[оo0][\W_]*[йj]|[аьуybau])|[еe][\W_]*(?:[тt][\W_]*[еe]|ш[\W_]*[ьb]))|[аыоуяюйиijoyau0]|[лl][\W_]*[иоiou0]|[чc][\W_]*[уyu])))|(?:[фf][\W_]*[иiu][\W_]*[гrg]|[хxh][\W_]*(?:[еиeiu][\W_]*(?:[йj][\W_]*)?[рpr]|[рpr][\W_]*[еe][\W_]*[нhn]|[уyu][\W_]*[йj]))|[хxh][\W_]*[уyu][\W_]*(?:[еёиeiu][\W_]*(?:[сsc][\W_]*[оo0][\W_]*[сsc]|[пnp][\W_]*[лl][\W_]*[еe][\W_]*[тt]|[нhn][\W_]*[ыi][\W_]*ш)(?:[\W_]*[аыуyiau]|[\W_]*[оаoa0][\W_]*[мm](?:[\W_]*[иiu])?|[нhn][\W_]*(?:[ыиiu][\W_]*[йj]|[аa][\W_]*я|[оo0][\W_]*[йеej]|[ыi][\W_]*[хxh]|[ыi][\W_]*[еe]|[ыi][\W_]*[мm](?:[\W_]*[иiu])?|[уyu][\W_]*ю|[оo0][\W_]*[мm][\W_]*[уyu]))?|[дd][\W_]*[оo0][\W_]*ё[\W_]*[бb6][\W_]*[иiu][\W_]*[нhn][\W_]*(?:[оo0][\W_]*[йj]|[аеыуeyiau]))|[бb6][\W_]*[лl][\W_]*я(?:[\W_]*[дтdt][\W_]*(?:[ьb]|[иiu]|[кk][\W_]*[иiu]|[сsc][\W_]*[тt][\W_]*[вbv][\W_]*[оo0]|[сsc][\W_]*[кk][\W_]*(?:[оo0][\W_]*[ейej]|[иiu][\W_]*[еe]|[аa][\W_]*я|[иiu][\W_]*[йj]|[оo0][\W_]*[гrg][\W_]*[оo0])))?|[вbv][\W_]*[ыi][\W_]*[бb6][\W_]*[лl][\W_]*я[\W_]*[дd][\W_]*(?:[оo0][\W_]*[кk]|[кk][\W_]*(?:[иуаеeiyau]|[аa][\W_]*[мm](?:[\W_]*[иiu])?))|(?:[з3z][\W_]*[аоoa0][\W_]*)(?:[пnp][\W_]*[аоoa0][\W_]*[дd][\W_]*[лl][\W_]*[оыаoia0]|[лl][\W_]*[уyu][\W_]*[пnp][\W_]*(?:[оo0][\W_]*[йj]|[аеыуeyiau]))|ш[\W_]*[лl][\W_]*ю[\W_]*[хxh][\W_]*(?:[ауеиeiyau]|[оo0][\W_]*[йj])|[аa][\W_]*[нhn][\W_]*[уyu][\W_]*[сsc](?:[\W_]*[еаыуeyiau]|[\W_]*[оo0][\W_]*[мm])?|(?:\w*(?:[хxh](?:[рpr][еe][нhn]|[уyu][иiu])|[пnp][еиeiu](?:[з3z][дd]|[дd](?:[еаоeoa0][рpr]|[рpr]))|[бb6][лl]я[дd]|[оo0][хxh][уyu][еe]|[мm][уyu][дd][еоиаeioau0]|[дd][еe][рpr][ьb]|[гrg][аоoa0][вbv][нhn]|[уyu][еёe][бb6])|[хxh][\W_]*(?:[рpr][\W_]*[еe][\W_]*[нhn]|[уyu][\W_]*[йиеяeiju])|[пnp][\W_]*[еиeiu][\W_]*(?:[з3z][\W_]*[дd]|[дd][\W_]*(?:[еаоeoa0][\W_]*[рpr]|[рpr]))|[бb6][\W_]*[лl][\W_]*я[\W_]*[дd]|[оo0][\W_]*[хxh][\W_]*[уyu][\W_]*[еe]|[мm][\W_]*[уyu][\W_]*[дd][\W_]*[еоиаeioau0]|[дd][\W_]*[еe][\W_]*[рpr][\W_]*[ьb]|[гrg][\W_]*[аоoa0][\W_]*[вbv][\W_]*[нhn]|[уyu][\W_]*[еёe][\W_]*[бb6]|[ёеe][бb6])\w+';
		$self->{'bip'}='бип';
		$self->{'word'} = decode('UTF-8', $self->{'word'});
	} else {
		$self->{'word'}='a[\W_]*s[\W_]*s(?:[\W_]*e[\W_]*s)?|f[\W_]*u[\W_]*c[\W_]*k(?:[\W_]*i[\W_]*n[\W_]*g)?|[\W_]*(?:[iu][\W_]*[d](?:[\W_]*[yiau]|[\W_]*[o0][\W_]*[bv])?|[o0][\W_]*[np][\W_]*(?:[a](?:[\W_]*[xh])?|[eyiu]|[o0][\W_]*[j]))|[d][\W_]*[e][\W_]*[pr][\W_]*(?:[b][\W_]*)?[m][\W_]*[eoya0u](?:[\W_]*[m])?|[c][\W_]*[m][\W_]*(?:[o0]|[i][\W_]*[pr][\W_]*[eibu])|[sc][\W_]*[uy][\W_]*(?:(?:[c][\W_]*)?[k][\W_]*[iyau](?:[\W_]*[hn](?:[\W_]*[o0][\W_]*[j]|[\W_]*[yiau])?)?|[c][\W_]*(?:(?:[b][\W_]*)?(?:[eiu]|[eiu][\W_]*[j])|[a][\W_]*[pr][\W_]*[eyiau]))|[rg][\W_]*(?:[oa0][\W_]*(?:[hn][\W_]*[d][\W_]*[oa0][\W_]*[hn](?:[\W_]*[yiu])?|[bv][\W_]*[hn][\W_]*[oa0](?:[\W_]*(?:[m]|[e][\W_]*[d](?:[\W_]*[eyiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?)?))?)|[hn][\W_]*(?:[iu][\W_]*[d][\W_]*(?:[eyiau]|[o0][\W_]*[j])|[yu][sc](?:[\W_]*[yiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?)?))|(?:[hn][\W_]*[e][\W_]*)?(?:(?:[3z][\W_]*[a]|[o0][t]|[np][\W_]*[o0]|[np][\W_]*(?:[e][\W_]*[pr][\W_]*[e]|[pr][\W_]*[eiou0]|[iu][\W_]*[3z][\W_]*[d][\W_]*[o0])|[hn][\W_]*[a]|[iu][\W_]*[3z]|[d][\W_]*[o0]|[bv][\W_]*[i]|[yu]|[pr][\W_]*[a][\W_]*[3z]|[3z][\W_]*[l][\W_]*[o0]|[t][\W_]*[pr][\W_]*[o0]|[yu])[\W_]*)?(?:[bv][\W_]*[i][\W_]*)?(?:[b][\W_]*)?(?:[e][\W_]*[b6](?:(?:[\W_]*[eioyau0])?(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)?(?:[\W_]*[bv][\W_]*[a])?(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:(?:[b][\W_]*)?[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[o0]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[k](?:[\W_]*[iau])?|[a][\W_]*[l](?:[\W_]*[sc][\W_]*)?|[l][\W_]*(?:[a][\W_]*[hn]|[oa0](?:[\W_]*[m])?|(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu]|[a][\W_]*[sc][\W_]*[b])|[pr][\W_]*[b]|[sc][\W_]*[b]|[hn][\W_]*[o0]|[c][\W_]*(?:[iu][\W_]*[xh]|[e][\W_]*[sc][\W_]*[t][\W_]*[ibu](?:[\W_]*)?)|(?:[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*|[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?)|[ijltcu]))?)|[\W_]*[i](?:(?:[\W_]*[bv][\W_]*[a]|[\W_]*[hn](?:[\W_]*[hn])?)(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:[b][\W_]*[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[l][\W_]*(?:(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu]|[a][\W_]*[sc][\W_]*[b])|(?:[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?))))|[pr][\W_]*[b]))|[\W_]*[b6](?:[\W_]*[eioyau0])?(?:(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)?(?:(?:[\W_]*(?:[eiu][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*(?:[b][\W_]*[sc][\W_]*|[b]|[e][\W_]*[sc][\W_]*[b]|[e]|[iu][\W_]*[hn][\W_]*[eyiau])|(?:[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[eiu][\W_]*[e]|[e][\W_]*[rg][\W_]*[o0])|[\W_]*[t])(?:[\W_]*[sc][\W_]*)?|[e][\W_]*[mt]|[k](?:[\W_]*[iau])?|[a][\W_]*[l](?:[\W_]*[sc][\W_]*)?|[l][\W_]*(?:[a][\W_]*[hn]|[oa0](?:[\W_]*[m])?|(?:[iu][\W_]*)?[sc][\W_]*[b]|[iu])|[pr][\W_]*[b]|[sc][\W_]*[b]|[hn][\W_]*[o0]|[c][\W_]*(?:[iu][\W_]*[xh]|[e][\W_]*[sc][\W_]*[t][\W_]*[ibu](?:[\W_]*)?)|(?:[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*|[sc][\W_]*[t][\W_]*|[l][\W_]*[iu][\W_]*[bv][\W_]*|[tc][\W_]*)?(?:[a][\W_]*|[o0][\W_]*[ejm]|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[iu][\W_]*[e]|[o0][\W_]*[m][\W_]*[yu]|[iu][\W_]*[j]|[e][\W_]*[bv]|[iu][\W_]*[m](?:[\W_]*[iu])?)|[ijlmcu]))|(?:[\W_]*[hn](?:[\W_]*[hn])?[\W_]*[iybau]?)))|[\W_]*[b6][\W_]*(?:[eiyau][\W_]*)?(?:[hn][\W_]*(?:[hn][\W_]*)?(?:[iybau][\W_]*)?)?[t])|[sc][\W_]*[b][\W_]*[e][\W_]*[b6][\W_]*(?:[yu]|(?:[eiyau](?:[\W_]*[l](?:[\W_]*[ioau0])?|[\W_]*[\W_]*[b]|[\W_]*[t][\W_]*[e])?(?:[\W_]*[sc][\W_]*[b])?))|[e][\W_]*(?:[b6][\W_]*(?:[yu][\W_]*[k][\W_]*[e][\W_]*[hn][\W_]*[t][\W_]*[iu][\W_]*[j]|[e][\W_]*[hn][\W_]*(?:[b]|(?:[\W_]*[m])?)|[iu][\W_]*(?:[c][\W_]*[k][\W_]*[a][\W_]*|[c][\W_]*[e][\W_]*[sc][\W_]*[k][\W_]*[a][\W_]*)|[l][\W_]*[iu][\W_]*[\W_]*[e]|[a][\W_]*(?:[l][\W_]*[b][\W_]*[hn][\W_]*[iu][\W_]*[k](?:[\W_]*[iau])?|[t][\W_]*[o0][\W_]*[pr][\W_]*[iu][\W_]*[j]|[hn][\W_]*(?:[t][\W_]*[pr][\W_]*[o0][\W_]*[np]|[a][\W_]*[t][\W_]*[iu][\W_]*(?:[k]|[c][\W_]*[e][\W_]*[sc][\W_]*[k][\W_]*[iu][\W_]*[j]))))|[d][\W_]*[pr][\W_]*[iu][\W_]*[t])|[hn][\W_]*[e][\W_]*[bv][\W_]*[pr][\W_]*[o0][\W_]*[t][\W_]*[\W_]*[e][\W_]*[b6][\W_]*[a][\W_]*[t][\W_]*[e][\W_]*[l][\W_]*[b][\W_]*[sc][\W_]*[k][\W_]*[iu][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[yu][\W_]*(?:[e][\W_]*[b6][\W_]*(?:[iu][\W_]*[\W_]*[ea]|[a][\W_]*[hn](?:[\W_]*[t][\W_]*[yu][\W_]*[sc])?(?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eyiau])?)|[pr][\W_]*[o0][\W_]*[d](?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eyiau])?|[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*(?:[o0][\W_]*[k]|[k][\W_]*(?:[oa0][\W_]*[bmv](?:[\W_]*[iu])?|[eiyau])?))|[m][\W_]*(?:[yu][\W_]*[d][\W_]*(?:[o0][\W_]*[xh][\W_]*[a][\W_]*(?:[t][\W_]*[b][\W_]*[sc][\W_]*|[\W_]*[sc][\W_]*[b]|[e][\W_]*[\W_]*[b][\W_]*[sc][\W_]*)|[a][\W_]*(?:[k](?:[\W_]*[iau]|[o0][bmv])?|[c][\W_]*(?:[b][\W_]*[e]|[iu][\W_]*[hn][\W_]*[yiau]|[k][\W_]*(?:[eiyau]|[o0][\W_]*[j])))|[e][\W_]*[hn][\W_]*[b]|[iu][\W_]*[l](?:[\W_]*[eoia0]?))|[a][\W_]*[hn][\W_]*[d][\W_]*[yau]|[l][\W_]*(?:[iu][\W_]*[hn]|))|(?:[m][\W_]*(?:[o0][\W_]*[3z][\W_]*[rg]|[yu][\W_]*[d])|[d][\W_]*(?:[o0][\W_]*[l][\W_]*[b6]|[yu][\W_]*[pr])|[sc][\W_]*[k][\W_]*[o0][\W_]*[t]|[\W_]*[iu][\W_]*[d])[\W_]*[oa0][\W_]*(?:[xh][\W_]*[yu][\W_]*[iju]|[e][\W_]*[b6](?:[\W_]*[eo0][\W_]*[bv]|[\W_]*[ia]|[\W_]*[sc][\W_]*[t][\W_]*[bv][\W_]*[oy0u](?:[\W_]*[m])?|[iu][\W_]*[3z][\W_]*[m])?)|(?:[hn][\W_]*[e][\W_]*|[3z][\W_]*[a][\W_]*|[o0][\W_]*[t][\W_]*|[np][\W_]*[o0][\W_]*|[hn][\W_]*[a][\W_]*|[pr][\W_]*[a][\W_]*[3szc][\W_]*)?(?:[np][\W_]*[iu][\W_]*[3z][\W_]*[d][\W_]*[eiu]|(?:)?[e][\W_]*[b6][\W_]*[a])[\W_]*(?:(?:[t][\W_]*[b][\W_]*[sc][\W_]*|[t][\W_]*[b]|[l][\W_]*[iu]|[a][\W_]*[l]|[l]|c[\W_]*[b]|[iu][\W_]*[t]|[iu]|[t][\W_]*[e]|[c][\W_]*[yu]|[\W_]*[b])|(?:[iju]|[eiu][\W_]*[m](?:[\W_]*[iu])?|[j][\W_]*[sc][\W_]*(?:[k][\W_]*(?:[iu][\W_]*[ej]|[a][\W_]*|[o0][\W_]*[e]|[i][\W_]*[xh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[t][\W_]*[bv][\W_]*[oya0u](?:[\W_]*[m])?)))|[np][\W_]*[eiu][\W_]*[d][\W_]*[eoa0][\W_]*[pr](?:(?:[\W_]*[a][\W_]*[3szc](?:(?:[\W_]*[t])?(?:[\W_]*[i]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[\W_]*[k][\W_]*[iau])?|(?:[\W_]*[eyiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[\W_]*[o0][\W_]*[bv])))|[\W_]*(?:[eyiau]|[oa0][\W_]*[m](?:[\W_]*[iu])?|[o0][\W_]*[bv]|[hn][\W_]*))?|[np][\W_]*[iu][\W_]*[3z][\W_]*(?:[b][\W_]*)?[d][\W_]*(?:[e][\W_]*(?:[hn][\W_]*[i][\W_]*(?:[\W_]*[b])?|[hn](?:[\W_]*[b])?)|[yu][\W_]*(?:[j](?:[\W_]*[t][\W_]*[e])?|[hn](?:[\W_]*[i])?)|[\W_]*(?:[k](?:[\W_]*(?:[eiyau]|[o0][\W_]*[bv]|[a][\W_]*[m](?:[\W_]*[iu])?))?|[l](?:[ibu]|[e][\W_]*[j]|[\W_]*[mxh]))|[e][\W_]*[c]|[oa0][\W_]*(?:[hn][\W_]*[yu][\W_]*)?[t][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0](?:[\W_]*[ej])?|[i][\W_]*[ejxh]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu]|[e][\W_]*[e]|[eyibau])|[a][\W_]*[hn][\W_]*[yu][\W_]*[l](?:[\W_]*[iau])?|[eiyau]|[oa0][\W_]*(?:[j]|[xh][\W_]*[yu][\W_]*[j]|[e][\W_]*[b6]|(?:[pr][\W_]*[o0][\W_]*[t]|[rg][\W_]*[o0][\W_]*[l][\W_]*[o0][\W_]*[bv])[\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])|[b6][\W_]*(?:[pr][\W_]*[a][\W_]*[t][\W_]*[iu][\W_]*|[o0][\W_]*[l](?:[\W_]*[yiau])?)))|[np][\W_]*(?:[a][\W_]*[d][\W_]*[l][\W_]*[oia0]|[oa0][\W_]*[sc][\W_]*[k][\W_]*[yu][\W_]*[d][\W_]*(?:[eyiau]|[oa0][\W_]*[m](?:[\W_]*[iu])?)|[eiu][\W_]*[d][\W_]*(?:[iu][\W_]*[k]|[pr][\W_]*[iu][\W_]*[l](?:[\W_]*[l])?)(?:[\W_]*[oa0][\W_]*[bmv]|[\W_]*[eioyau0])?|[pr][\W_]*[o0][\W_]*[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*[o0][\W_]*[m])|(?:[3z][\W_]*[a][\W_]*|[o0][\W_]*[t][\W_]*|[hn][\W_]*[a][\W_]*)?[sc][\W_]*[pr][\W_]*(?:[a][\W_]*[t][\W_]*[b]|[a][\W_]*[l](?:[\W_]*[iu])?|[eiyu])|[sc][\W_]*[pr][\W_]*[a][\W_]*(?:[k][\W_]*(?:[eiyau]|[o0][\W_]*[j])|[hn](?:[\W_]*[hn])?(?:[b]|(?:[\W_]*[i][\W_]*[ej]|[\W_]*[a][\W_]*|[\W_]*[o0][\W_]*[e]))|[l][\W_]*[b][\W_]*[hn][\W_]*[iu][\W_]*[k](?:[\W_]*[iu]|[\W_]*[oa0][\W_]*[m])?)|(?:[3z][\W_]*[a][\W_]*)?[t][\W_]*[pr][\W_]*[a][\W_]*[xh][\W_]*(?:[hn][\W_]*(?:[yu](?:[\W_]*[t][\W_]*[b](?:[\W_]*[sc][\W_]*)?|[\W_]*[sc][\W_]*[b]|[\W_]*[l](?:[\W_]*[iau])?)?|[eiu][\W_]*[\W_]*[b][\W_]*[sc][\W_]*)|[a][\W_]*(?:[l](?:[\W_]*[ioau0])?|[t][\W_]*[b](?:[\W_]*[sc][\W_]*)?|[hn][\W_]*(?:[hn][\W_]*)?(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu])))|(?:[hn][\W_]*[eiu][\W_]*|[np][\W_]*[o0][\W_]*|[hn][\W_]*[a][\W_]*|[oa0][\W_]*(?:[t][\W_]*)?|[d][\W_]*[oa0][\W_]*|[3z][\W_]*[a][\W_]*)?(?:(?:[f][\W_]*[iu][\W_]*[rg]|[xh][\W_]*(?:[eiu][\W_]*(?:[j][\W_]*)?[pr]|[pr][\W_]*[e][\W_]*[hn]|[yu](?:[\W_]*[j])?))(?:[\W_]*[eo0][\W_]*[bv](?:[\W_]*[a][\W_]*[\W_]*|[\W_]*)?)?(?:[\W_]*[eiau][\W_]*[lhn])?(?:[hn])?(?:[\W_]*(?:[eioau0][beijmvu]|[\W_]*(?:[m](?:[\W_]*[iu])?|[pr][\W_]*(?:|[iu][\W_]*(?:[t](?:[\W_]*[eb][\W_]*[sc][\W_]*[b])?|[l](?:[\W_]*[ioau0])?))|[c][\W_]*(?:[iau][\W_]*[t](?:[\W_]*[sc][\W_]*)|[iu][\W_]*[l](?:[\W_]*[ioau0])?)|[c](?:[\W_]*[b])?)|[e][\W_]*(?:[t][\W_]*(?:[o0][\W_]*[j]|[ybau])|[e][\W_]*(?:[t][\W_]*[e]|[\W_]*[b]))|[ijoyau0]|[l][\W_]*[iou0]|[c][\W_]*[yu])))|(?:[f][\W_]*[iu][\W_]*[rg]|[xh][\W_]*(?:[eiu][\W_]*(?:[j][\W_]*)?[pr]|[pr][\W_]*[e][\W_]*[hn]|[yu][\W_]*[j]))|[xh][\W_]*[yu][\W_]*(?:[eiu][\W_]*(?:[sc][\W_]*[o0][\W_]*[sc]|[np][\W_]*[l][\W_]*[e][\W_]*[t]|[hn][\W_]*[i][\W_]*)(?:[\W_]*[yiau]|[\W_]*[oa0][\W_]*[m](?:[\W_]*[iu])?|[hn][\W_]*(?:[iu][\W_]*[j]|[a][\W_]*|[o0][\W_]*[ej]|[i][\W_]*[xh]|[i][\W_]*[e]|[i][\W_]*[m](?:[\W_]*[iu])?|[yu][\W_]*|[o0][\W_]*[m][\W_]*[yu]))?|[d][\W_]*[o0][\W_]*[\W_]*[b6][\W_]*[iu][\W_]*[hn][\W_]*(?:[o0][\W_]*[j]|[eyiau]))|[b6][\W_]*[l][\W_]*(?:[\W_]*[dt][\W_]*(?:[b]|[iu]|[k][\W_]*[iu]|[sc][\W_]*[t][\W_]*[bv][\W_]*[o0]|[sc][\W_]*[k][\W_]*(?:[o0][\W_]*[ej]|[iu][\W_]*[e]|[a][\W_]*|[iu][\W_]*[j]|[o0][\W_]*[rg][\W_]*[o0])))?|[bv][\W_]*[i][\W_]*[b6][\W_]*[l][\W_]*[\W_]*[d][\W_]*(?:[o0][\W_]*[k]|[k][\W_]*(?:[eiyau]|[a][\W_]*[m](?:[\W_]*[iu])?))|(?:[3z][\W_]*[oa0][\W_]*)(?:[np][\W_]*[oa0][\W_]*[d][\W_]*[l][\W_]*[oia0]|[l][\W_]*[yu][\W_]*[np][\W_]*(?:[o0][\W_]*[j]|[eyiau]))|[\W_]*[l][\W_]*[\W_]*[xh][\W_]*(?:[eiyau]|[o0][\W_]*[j])|[a][\W_]*[hn][\W_]*[yu][\W_]*[sc](?:[\W_]*[eyiau]|[\W_]*[o0][\W_]*[m])?|(?:\w*(?:[xh](?:[pr][e][hn]|[yu][iu])|[np][eiu](?:[3z][d]|[d](?:[eoa0][pr]|[pr]))|[b6][l][d]|[o0][xh][yu][e]|[m][yu][d][eioau0]|[d][e][pr][b]|[rg][oa0][bv][hn]|[yu][e][b6])|[xh][\W_]*(?:[pr][\W_]*[e][\W_]*[hn]|[yu][\W_]*[eiju])|[np][\W_]*[eiu][\W_]*(?:[3z][\W_]*[d]|[d][\W_]*(?:[eoa0][\W_]*[pr]|[pr]))|[b6][\W_]*[l][\W_]*[\W_]*[d]|[o0][\W_]*[xh][\W_]*[yu][\W_]*[e]|[m][\W_]*[yu][\W_]*[d][\W_]*[eioau0]|[d][\W_]*[e][\W_]*[pr][\W_]*[b]|[rg][\W_]*[oa0][\W_]*[bv][\W_]*[hn]|[yu][\W_]*[e][\W_]*[b6]|[e][b6])\w+';
		$self->{'bip'}='';
	}

	bless $self,$class;
	return $self;
}

sub remove_slang
{
	my ($self,$slang)=@_;

	if (defined($self->{'codepage'}) && ($self->{'codepage'} eq 'utf-8')) {
		$slang = decode('UTF-8', $slang);
	}
	eval {
		#$slang =~ s/(?<=[\W_])($self->{'word'})(?=[\W_])/$self->{'bip'}/gi;
		#$slang =~ s/(\b|_)(?:$self->{'word'})(\b|_)/$1bip$2/gi;
		#$slang =~ s/(?:\b|_)(?:$self->{'word'})(?:\b|_)//gi;
		$slang =~ s/(?:\b|(?<=_))(?:$self->{'word'})(?:\b|(?=_))/$self->{'bip'}/gi;
	};
	if (defined($self->{'codepage'}) && ($self->{'codepage'} eq 'utf-8')) {
		$slang = encode('UTF-8', $slang);
	}
	die "Fatal error: bad regular expression!" if $@;
	return $slang; 
}


sub detect_slang
{
	my ($self,$slang)=@_;
	my $match;
	eval {
		$match = ($slang =~ m/(?:\b|(?<=_))(?:$self->{'word'})(?:\b|(?=_))/i);
	};
	die "Fatal error: bad regular expression!" if $@;
	return $match; 
}

sub set_bip
{
	my ($self,$bip)=@_;
	$self->{'bip'}=$bip;
}

sub load_dict
{
	my ($self,$file)=@_;
	
	local($/) = undef;
	my $FH = new FileHandle("$file")||die "Can't open $file!";
	my $dict = <$FH>;
	close($FH);
	$dict =~ s/\015?\012/|/g;

	if (defined($self->{'codepage'}) && ($self->{'codepage'} eq 'utf-8')) {
		$dict = decode('UTF-8', $dict);
	}

	eval { '1' =~ m/$dict/; };
	die "Bad regular expression in dictionary $file!" if $@;
	
	$self->{'word'} = $self->{'word'} . '|' . $dict;
}

1;

__END__


=head1 NAME

Lingua::RU::Antimat - Perl Module for removal Russian slang from chat, guestbooks, etc.

=head1 SYNOPSIS

use POSIX qw(locale_h);

use Lingua::RU::Antimat;

use locale;

setlocale(LC_CTYPE,"ru_RU.CP1251"); 

$dirty_text='text with slang';

$mat= Lingua::RU::Antimat->new;

#load dictionary with additional words

$mat->load_dict('/home/www/badwords');

$mat->set_bip('Sorry!');

$clean_text=$mat->remove_slang($dirty_text);


=head1 RUSSIAN DOCUMENTATION

Detailed Russian documentation and tutorial available on http://www.tcen.ru/antimat

=head1 DESCRIPTION

This module will remove Russian slang from a string. 'Mat' is Russian name for such bad words and  that is why this module is called Antimat. 

=over

=item $mat=Lingua::RU::Antimat->new($codepage);

This method creates a new object and returns it.
If new() is called without any arguments, the module will use templates for text in encoding win-1251.
If your text in encoding KOI8-R set $codepage equal 'koi8'.
If your text in encoding UTF-8 set $codepage equal 'utf-8'.

Examples:

$mat=Lingua::RU::Antimat->new; #for text in win-1251

$mat=Lingua::RU::Antimat->new('koi8'); #for text in KOI8-R

$mat=Lingua::RU::Antimat->new('utf-8'); #for text in UTF-8

=item $clean_text=$mat->remove_slang($dirty_text);

Method remove_slang takes string and returns string where all 
bad words replaced on Russian analog 'bip' or string you set in method set_bip
which is described later.

=item $badwords=$mat->detect_slang($dirty_text);

Method detect_slang takes string and returns boolean value. This value equal 1
if there is bad word in the string and 0 if there is no such words in the string. 

=item $mat->set_bip($bip);

Set the string (usually word) which will replace bad words in method remove_slang.

Examples:

$mat->set_bip(''); #let strip out slang

$mat->set_bip('I am sorry!'); #long but also correct

=item $mat->load_dict($file);

This method loads dictionary with additional bad words. Each string in the dictionary should be a word or regular expression. $file could be relative or absolute path to the dictionary.

=back

=head1 SEE ALSO

Detailed Russian documentation on http://www.tcen.ru/antimat

perllocale manpage

=head1 CREDITS

Andrey Skorohod, marlenus@marlenus.com for his bug reports.
Vladimir Zhdanov, vovka@lg.kamaz.net for his bug report.
Andrey Sharapov, Sharapov@tut.by for his suggestions.
Yury Voloshin, xtc@norilsk.net for his bug report and suggestions.

Thanks!

=head1 AUTHOR

Ilya Soldatkin, arc@tcen.ru

Drop me a line if you deploy this module on your site. Think about this as a small contribution to my efforts for writing and supporting this module. I can not improve this module if I will know that no one uses it. 

=head1 COPYRIGHT

Copyright 2001-2003 Ilya Soldatkin. All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
